
#include <p18cxxx.h>

#include "GLCD.h"



#pragma config OSC = HS
#pragma config WDT = OFF
#pragma config LVP = OFF
void main(void)
{
	unsigned char t;
	int px,py,px2,py2;
	int x,y,x2,y2;
	int dx,dy,dx2,dy2; 
	ADCON1 = 0x07;
	TRISE = 0;
	TRISA = TRISB = 0;  //TRISC = TRISCA ----- TRISCD = TRISB
	init();

	x=40;y=30;x2=10;y2=55;
	px=x;py=y;px2=x2;py2=y2;
	dx=3;dy=-2;dx2=-3;dy2=3;
	while(1)
	{
		delay(1);
		line(px,py,px2,py2,0);
		line(x,y,x2,y2,1);
		px=x;py=y;px2=x2;py2=y2;
		x += dx;
		if((x<0)||(x>127))
		{
			dx = -dx;
			x = px;
			x += dx;
		}
		x2 += dx2;
		if((x2<0)||(x2>127))
		{
			dx2 = -dx2;
			x2 = px2;
			x2 += dx2;
		}
		y += dy;
		if((y<0)||(y>63))
		{
			dy = -dy;
			y = py;
			y += dy;
		}
		y2 += dy2;
		if((y2<0)||(y2>63))
		{
			dy2 = -dy2;
			y2 = py2;
			y2 += dy2;
		}
	}
}

void line(int x1,int y1,int x2,int y2,unsigned char color)
{
	int steep,temp,error,deltaerror;
	int xstep,ystep,deltax,deltay,x,y;
	steep = abs(y2-y1) > abs(x2-x1);
	if (steep)
	{
		temp=x1; x1=y1; y1=temp;	//swap x1,y1
		temp=x2; x2=y2; y2=temp;	//swap x2,y2
	}
	deltax = abs(x2-x1);			//x Difference
	deltay = abs(y2-y1);			//y Difference
	error = 0;				//overflow counter
	deltaerror = deltay;			//counter adder
	x = x1;					//start at x1,y1
	y = y1;
	if(x1 < x2)				//direction
		xstep = 1;
	else
		xstep = -1;
	if(y1 < y2)				//direction
		ystep = 1;
	else
		ystep = -1;
	if(steep)				//draw
		pixel(y,x,color);
	else
		pixel(x,y,color);
	while(x != x2)
	{
		x += xstep;			//move in x
		error += deltaerror;		//add to counter
		if((error << 1) > deltax)	//would it overflow?
		{
			y += ystep;		//move in y
			error = error - deltax;	//overflow/wrap the counter
		}
		if(steep)			//draw
			pixel(y,x,color);
		else
			pixel(x,y,color);
	}
}

void rect(unsigned char x,unsigned char y,unsigned char x2,unsigned char y2,unsigned char color)
{
	unsigned char hor,ver;
	for(hor=x;hor<x2+1;hor++)
	{
		for(ver=y;ver<y2+1;ver++)
			pixel(hor,ver,color);
	}
}

void pixel(unsigned char pix_x,unsigned char pix_y,unsigned char color)
{
	unsigned char page,temp,read_tmp;
	if(pix_x > 63)				//find which half of screen
	{					//and set CS1 & 2 accordingly
		pix_x-=64;			//calculate x address for right half
		CS1 = 0;
		CS2 = 1;
	}
	else
	{
		CS1 = 1;
		CS2 = 0;
	}
	cmd_write(0x40 + pix_x);		//set x address
	page = pix_y >> 3;			//find which page
	cmd_write(0xb8 + page);
	read_tmp = data_read();			//read old byte
	temp = pix_y - (page << 3);		//calculate bit position
	pix_y = 1;
	pix_y = pix_y << temp;			//make actual byte
	cmd_write(0x40 + pix_x);		//reset x address
	if(!color)				//OR new bit into old byte
		temp = read_tmp & ~pix_y;
	else
		temp = read_tmp | pix_y;
	data_write(temp);			//and write it to screen
}	

unsigned char data_read(void)
{
	unsigned char x;
	busy();
	TRISB = 0xff;
	DI = 1;RW = 1;
	Nop();
	E = 1;				//dummy read
	Nop();
	x = PORTB;
	E = 0;
	TRISB = 0;

	busy();
	TRISB = 0xff;
	DI = 1;RW = 1;
	Nop();
	E = 1;				//real read
	Nop();
	x = PORTB;
	E = 0;
	TRISB = 0;
	return x;
}

void data_write(unsigned char x)
{
	busy();
	DI = 1;
	RW = 0;
	PORTB = x;
	e_togg();
}
	
void cmd_write(unsigned char x)
{
	busy();
	DI = RW = 0;
	PORTB = x;
	e_togg();
}

void init(void)
{
	RST = 1;
	E = 0;
	CS1 = CS2 = 1;
	cmd_write(0x3f);		//turn on display
	cmd_write(0x40);		//go to left side
	cmd_write(0xb8);		//go to top page
	cls();				//clear the screen
}	

void busy(void)
{
	unsigned char stat;
	TRISB = 0xff;			//PORTB all inputs
	DI = 0;
	RW = 1;
	if(CS1==1&&CS2==1)
	{
		CS1 = 0;
		do
		{
			E = 1;
			Nop();
			stat = PORTB;
			E = 0;
		}while(stat==0x80);
		CS1 = 1;
		CS2 = 0;
		do
		{
			E = 1;
			Nop();
			stat = PORTB;
			E = 0;
		}while(stat==0x80);
		CS2 = 1;
	}
	else
	{
		do
		{
			E = 1;
			Nop();
			stat = PORTB;
			E = 0;
		}while(stat==0x80);
	}
	TRISB = 0;
}	
	
void cls(void)				//clear screen
{
	char x,y;
	CS1 = CS2 = 1;
	for(y=0;y<8;y++)		//page loop
	{
		cmd_write(0xb8 + y);
		for(x=0;x<64;x++)	//y loop
			data_write(0x00);
	}
	cmd_write(0xc0);		//display start line = 0
	cmd_write(0x40);		//go to left side
	cmd_write(0xb8);		//go to top page
}	

void e_togg(void)
{
	E = 1;
	Nop();
	E = 0;
}
	
void delay(int len)
{
	int x,y;
	for(x=0;x<len;x++)
	{
		for(y=0;y<22767;y++){}
	}
}

int abs(int n)
{
    return n > 0 ? n : -n;
}
